diff --git a/sys/dev/virtual/vmware/shared/vm_atomic.h b/sys/dev/virtual/vmware/shared/vm_atomic.h
index 7cdddc9..4a55a7a 100644
--- a/sys/dev/virtual/vmware/shared/vm_atomic.h
+++ b/sys/dev/virtual/vmware/shared/vm_atomic.h
@@ -102,9 +102,10 @@ long  _InterlockedCompareExchange(long volatile*, long, long);
 long  _InterlockedExchangeAdd(long volatile*, long);
 long  _InterlockedDecrement(long volatile*);
 long  _InterlockedIncrement(long volatile*);
+void  _ReadWriteBarrier(void);
 #pragma intrinsic(_InterlockedExchange, _InterlockedCompareExchange)
 #pragma intrinsic(_InterlockedExchangeAdd, _InterlockedDecrement)
-#pragma intrinsic(_InterlockedIncrement)
+#pragma intrinsic(_InterlockedIncrement, _ReadWriteBarrier)
 
 #if defined(VM_X86_64)
 long     _InterlockedAnd(long volatile*, long);
@@ -133,10 +134,21 @@ __int64  _InterlockedCompareExchange64(__int64 volatile*, __int64, __int64);
 #endif
 #endif /* _MSC_VER */
 
-#ifdef __arm__
+#if defined(__arm__) && !defined(FAKE_ATOMIC)
+/*
+ * LDREX without STREX or CLREX may cause problems in environments where the
+ * context switch may not clear the reference monitor - according ARM manual
+ * the reference monitor should be cleared after a context switch, but some
+ * may not like Linux kernel's non-preemptive context switch path. So use of
+ * ARM routines in kernel code may not be safe.
+ */
 #   if defined(__ARM_ARCH_7__) || defined(__ARM_ARCH_7A__) ||  \
        defined(__ARM_ARCH_7R__)|| defined(__ARM_ARCH_7M__)
 #      define VM_ARM_V7
+#      ifdef __KERNEL__
+#         warning LDREX/STREX may not be safe in linux kernel, since it      \
+          does not issue CLREX on context switch (as of 2011-09-29).
+#      endif
 #   else
 #     error Only ARMv7 extends the synchronization primitives ldrex/strex.   \
             For the lower ARM version, please implement the atomic functions \
@@ -172,7 +184,7 @@ Atomic_VolatileToAtomic64(volatile uint64 *var)
  *      Determine whether an lfence intruction is executed after
  *	every locked instruction.
  *
- *	Certain AMD processes have a bug (see bug 107024) that
+ *	Certain AMD processors have a bug (see bug 107024) that
  *	requires an lfence after every locked instruction.
  *
  *	The global variable AtomicUseFence controls whether lfence
@@ -369,7 +381,11 @@ static INLINE uint32
 Atomic_ReadWrite(Atomic_uint32 *var, // IN
                  uint32 val)         // IN
 {
-#ifdef __GNUC__
+#ifdef FAKE_ATOMIC
+   uint32 retval = var->value;
+   var->value = val;
+   return retval;
+#elif defined(__GNUC__)
 #ifdef VM_ARM_V7
    register volatile uint32 retVal;
    register volatile uint32 res;
@@ -383,7 +399,7 @@ Atomic_ReadWrite(Atomic_uint32 *var, // IN
       "bne 1b"
       : [retVal] "=&r" (retVal), [res] "=&r" (res)
       : [var] "r" (&var->value), [val] "r" (val)
-      : "memory", "cc"
+      : "cc"
    );
 
    dmb();
@@ -442,7 +458,14 @@ Atomic_ReadIfEqualWrite(Atomic_uint32 *var, // IN
                         uint32 oldVal,      // IN
                         uint32 newVal)      // IN
 {
-#ifdef __GNUC__
+#ifdef FAKE_ATOMIC
+   uint32 readVal = var->value;
+
+   if (oldVal == readVal) {
+     var->value = newVal;
+   }
+   return oldVal;
+#elif defined(__GNUC__)
 #ifdef VM_ARM_V7
    register uint32 retVal;
    register uint32 res;
@@ -451,14 +474,14 @@ Atomic_ReadIfEqualWrite(Atomic_uint32 *var, // IN
 
    __asm__ __volatile__(
    "1: ldrex %[retVal], [%[var]] \n\t"
-      "mov %[res], #1 \n\t"
+      "mov %[res], #0 \n\t"
       "teq %[retVal], %[oldVal] \n\t"
       "strexeq %[res], %[newVal], [%[var]] \n\t"
       "teq %[res], #0 \n\t"
       "bne 1b"
       : [retVal] "=&r" (retVal), [res] "=&r" (res)
       : [var] "r" (&var->value), [oldVal] "r" (oldVal), [newVal] "r" (newVal)
-      : "memory", "cc"
+      : "cc"
    );
 
    dmb();
@@ -503,7 +526,7 @@ Atomic_ReadIfEqualWrite(Atomic_uint32 *var, // IN
 #define Atomic_ReadIfEqualWrite32 Atomic_ReadIfEqualWrite
 
 
-#if defined(__x86_64__)
+#if defined(__x86_64__) || defined(VM_ARM_V7)
 /*
  *-----------------------------------------------------------------------------
  *
@@ -526,6 +549,29 @@ Atomic_ReadIfEqualWrite64(Atomic_uint64 *var, // IN
                           uint64 newVal)      // IN
 {
 #if defined(__GNUC__)
+#ifdef VM_ARM_V7
+   register uint64 retVal;
+   register uint32 res;
+
+   dmb();
+
+   __asm__ __volatile__(
+   "1: ldrexd %[retVal], %H[retVal], [%[var]] \n\t"
+      "mov %[res], #0 \n\t"
+      "teq %[retVal], %[oldVal] \n\t"
+      "teqeq %H[retVal], %H[oldVal] \n\t"
+      "strexdeq %[res], %[newVal], %H[newVal], [%[var]] \n\t"
+      "teq %[res], #0 \n\t"
+      "bne 1b"
+      : [retVal] "=&r" (retVal), [res] "=&r" (res)
+      : [var] "r" (&var->value), [oldVal] "r" (oldVal), [newVal] "r" (newVal)
+      : "cc"
+   );
+
+   dmb();
+
+   return retVal;
+#else // VM_ARM_V7 (assume x86*)
    uint64 val;
 
    /* Checked against the AMD manual and GCC --hpreg */
@@ -539,6 +585,7 @@ Atomic_ReadIfEqualWrite64(Atomic_uint64 *var, // IN
    );
    AtomicEpilogue();
    return val;
+#endif //VM_ARM_V7
 #elif defined _MSC_VER
    return _InterlockedCompareExchange64((__int64 *)&var->value,
 					(__int64)newVal,
@@ -570,7 +617,9 @@ static INLINE void
 Atomic_And(Atomic_uint32 *var, // IN
            uint32 val)         // IN
 {
-#ifdef __GNUC__
+#ifdef FAKE_ATOMIC
+   var->value &= val;
+#elif defined(__GNUC__)
 #ifdef VM_ARM_V7
    register volatile uint32 res;
    register volatile uint32 tmp;
@@ -579,13 +628,13 @@ Atomic_And(Atomic_uint32 *var, // IN
 
    __asm__ __volatile__(
    "1: ldrex %[tmp], [%[var]] \n\t"
-      "and %[tmp], %[val] \n\t"
+      "and %[tmp], %[tmp], %[val] \n\t"
       "strex %[res], %[tmp], [%[var]] \n\t"
       "teq %[res], #0 \n\t"
       "bne 1b"
       : [res] "=&r" (res), [tmp] "=&r" (tmp)
       : [var] "r" (&var->value), [val] "r" (val)
-      : "memory", "cc"
+      : "cc"
    );
 
    dmb();
@@ -634,7 +683,9 @@ static INLINE void
 Atomic_Or(Atomic_uint32 *var, // IN
           uint32 val)         // IN
 {
-#ifdef __GNUC__
+#ifdef FAKE_ATOMIC
+   var->value |= val;
+#elif defined(__GNUC__)
 #ifdef VM_ARM_V7
    register volatile uint32 res;
    register volatile uint32 tmp;
@@ -643,13 +694,13 @@ Atomic_Or(Atomic_uint32 *var, // IN
 
    __asm__ __volatile__(
    "1: ldrex %[tmp], [%[var]] \n\t"
-      "orr %[tmp], %[val] \n\t"
+      "orr %[tmp], %[tmp], %[val] \n\t"
       "strex %[res], %[tmp], [%[var]] \n\t"
       "teq %[res], #0 \n\t"
       "bne 1b"
       : [res] "=&r" (res), [tmp] "=&r" (tmp)
       : [var] "r" (&var->value), [val] "r" (val)
-      : "memory", "cc"
+      : "cc"
    );
 
    dmb();
@@ -698,7 +749,9 @@ static INLINE void
 Atomic_Xor(Atomic_uint32 *var, // IN
            uint32 val)         // IN
 {
-#ifdef __GNUC__
+#ifdef FAKE_ATOMIC
+   var->value ^= val;
+#elif defined(__GNUC__)
 #ifdef VM_ARM_V7
    register volatile uint32 res;
    register volatile uint32 tmp;
@@ -707,13 +760,13 @@ Atomic_Xor(Atomic_uint32 *var, // IN
 
    __asm__ __volatile__(
    "1: ldrex %[tmp], [%[var]] \n\t"
-      "eor %[tmp], %[val] \n\t"
+      "eor %[tmp], %[tmp], %[val] \n\t"
       "strex %[res], %[tmp], [%[var]] \n\t"
       "teq %[res], #0 \n\t"
       "bne 1b"
       : [res] "=&r" (res), [tmp] "=&r" (tmp)
       : [var] "r" (&var->value), [val] "r" (val)
-      : "memory", "cc"
+      : "cc"
    );
 
    dmb();
@@ -801,7 +854,9 @@ static INLINE void
 Atomic_Add(Atomic_uint32 *var, // IN
            uint32 val)         // IN
 {
-#ifdef __GNUC__
+#ifdef FAKE_ATOMIC
+   var->value += val;
+#elif defined(__GNUC__)
 #ifdef VM_ARM_V7
    register volatile uint32 res;
    register volatile uint32 tmp;
@@ -810,13 +865,13 @@ Atomic_Add(Atomic_uint32 *var, // IN
 
    __asm__ __volatile__(
    "1: ldrex %[tmp], [%[var]] \n\t"
-      "add %[tmp], %[val] \n\t"
+      "add %[tmp], %[tmp], %[val] \n\t"
       "strex %[res], %[tmp], [%[var]] \n\t"
       "teq %[res], #0 \n\t"
       "bne 1b"
       : [res] "=&r" (res), [tmp] "=&r" (tmp)
       : [var] "r" (&var->value), [val] "r" (val)
-      : "memory", "cc"
+      : "cc"
    );
 
    dmb();
@@ -904,7 +959,9 @@ static INLINE void
 Atomic_Sub(Atomic_uint32 *var, // IN
            uint32 val)         // IN
 {
-#ifdef __GNUC__
+#ifdef FAKE_ATOMIC
+   var->value -= val;
+#elif defined(__GNUC__)
 #ifdef VM_ARM_V7
    register volatile uint32 res;
    register volatile uint32 tmp;
@@ -913,13 +970,13 @@ Atomic_Sub(Atomic_uint32 *var, // IN
 
    __asm__ __volatile__(
       "1: ldrex %[tmp], [%[var]] \n\t"
-      "sub %[tmp], %[val] \n\t"
+      "sub %[tmp], %[tmp], %[val] \n\t"
       "strex %[res], %[tmp], [%[var]] \n\t"
       "teq %[res], #0 \n\t"
       "bne 1b"
       : [res] "=&r" (res), [tmp] "=&r" (tmp)
       : [var] "r" (&var->value), [val] "r" (val)
-      : "memory", "cc"
+      : "cc"
    );
 
    dmb();
@@ -1007,7 +1064,7 @@ static INLINE void
 Atomic_Inc(Atomic_uint32 *var) // IN
 {
 #ifdef __GNUC__
-#ifdef VM_ARM_V7
+#if defined(VM_ARM_V7) || defined(FAKE_ATOMIC)
    Atomic_Add(var, 1);
 #else // VM_ARM_V7
    /* Checked against the Intel manual and GCC --walken */
@@ -1053,7 +1110,7 @@ static INLINE void
 Atomic_Dec(Atomic_uint32 *var) // IN
 {
 #ifdef __GNUC__
-#ifdef VM_ARM_V7
+#if defined(VM_ARM_V7) || defined(FAKE_ATOMIC)
    Atomic_Sub(var, 1);
 #else // VM_ARM_V7
    /* Checked against the Intel manual and GCC --walken */
@@ -1235,22 +1292,27 @@ static INLINE uint32
 Atomic_FetchAndAddUnfenced(Atomic_uint32 *var, // IN
                            uint32 val)         // IN
 {
-#ifdef __GNUC__
+#ifdef FAKE_ATOMIC
+   uint32 res = var->value;
+   var->value = res + val;
+   return res;
+#elif defined(__GNUC__)
 #ifdef VM_ARM_V7
    register volatile uint32 res;
    register volatile uint32 retVal;
+   register volatile uint32 tmp;
 
    dmb();
 
    __asm__ __volatile__(
       "1: ldrex %[retVal], [%[var]] \n\t"
-      "add %[val], %[retVal] \n\t"
-      "strex %[res], %[val], [%[var]] \n\t"
+      "add %[tmp], %[val], %[retVal] \n\t"
+      "strex %[res], %[tmp], [%[var]] \n\t"
       "teq %[res], #0 \n\t"
       "bne 1b"
-      : [res] "=&r" (res), [retVal] "=&r" (retVal)
+      : [tmp] "=&r" (tmp), [res] "=&r" (res), [retVal] "=&r" (retVal)
       : [var] "r" (&var->value), [val] "r" (val)
-      : "memory", "cc"
+      : "cc"
    );
 
    dmb();
@@ -1314,7 +1376,7 @@ static INLINE uint32
 Atomic_FetchAndAdd(Atomic_uint32 *var, // IN
                    uint32 val)         // IN
 {
-#if defined(__GNUC__) && !defined(VM_ARM_V7)
+#if defined(__GNUC__) && !defined(VM_ARM_V7) && !defined(FAKE_ATOMIC)
    val = Atomic_FetchAndAddUnfenced(var, val);
    AtomicEpilogue();
    return val;
@@ -1362,6 +1424,30 @@ Atomic_ReadAdd64(Atomic_uint64 *var, // IN
 #error No compiler defined for Atomic_ReadAdd64
 #endif
 }
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Atomic_ReadSub64 --
+ *
+ *      Atomic read (returned), sub a value, write.
+ *
+ * Results:
+ *      The value of the variable before the operation.
+ *
+ * Side effects:
+ *      None
+ *
+ *-----------------------------------------------------------------------------
+ */
+
+static INLINE uint64
+Atomic_ReadSub64(Atomic_uint64 *var, // IN
+                 uint64 val)         // IN
+{
+   // Do an sub by an add and a overflow
+   return Atomic_ReadAdd64(var, -val);
+}
 #endif
 
 
@@ -1537,9 +1623,20 @@ Atomic_CMPXCHG64(Atomic_uint64 *var,   // IN/OUT
                  uint64 const *oldVal, // IN
                  uint64 const *newVal) // IN
 {
-#ifdef __GNUC__
-   Bool equal;
+#ifdef FAKE_ATOMIC
+   uint64 readVal = var->value;
+
+   if (*oldVal == readVal) {
+     var->value = *newVal;
+   }
+   return (*oldVal == readVal);
+#elif defined(__GNUC__)
+#if defined(VM_ARM_V7)
+   return (Atomic_ReadIfEqualWrite64(var, *oldVal, *newVal) == *oldVal);
+
+#else // VM_ARM_V7
 
+   Bool equal;
    /* Checked against the Intel manual and GCC --walken */
 #if defined(__x86_64__)
    uint64 dummy;
@@ -1553,7 +1650,7 @@ Atomic_CMPXCHG64(Atomic_uint64 *var,   // IN/OUT
         "2" (*oldVal)
       : "cc"
    );
-#elif !defined(VM_ARM_V7) /* 32-bit version for non-ARM */
+#else /* 32-bit version for non-ARM */
    int dummy1, dummy2;
 #   if defined __PIC__
    /*
@@ -1572,8 +1669,14 @@ Atomic_CMPXCHG64(Atomic_uint64 *var,   // IN/OUT
     *    %ebx. (This happens when compiling the Fusion UI with gcc 4.2.1, Apple
     *    build 5577.)
     *
+    * 3) Using register classes even for other values is problematic, as gcc
+    *    can decide e.g. %ecx == %edi == 0 (as compile-time constants) and
+    *    ends up using one register for two things. Which breaks xchg's ability
+    *    to temporarily put the PIC pointer somewhere else. PR772455
+    *
     * For that reason alone, the __asm__ statement should keep the regions
-    * where it temporarily modifies %ebx as small as possible.
+    * where it temporarily modifies %ebx as small as possible, and should
+    * prefer specific register assignments.
     */
 #      if __GNUC__ < 3 // Part of #188541 - for RHL 6.2 etc.
    __asm__ __volatile__(
@@ -1602,20 +1705,22 @@ Atomic_CMPXCHG64(Atomic_uint64 *var,   // IN/OUT
       "lock; cmpxchg8b (%3)" "\n\t"
       "xchgl %%ebx, %6"      "\n\t"
       "sete %0"
-      :	"=qm,qm" (equal),
-	"=a,a" (dummy1),
-	"=d,d" (dummy2)
+      :	"=qm" (equal),
+	"=a" (dummy1),
+	"=d" (dummy2)
       : /*
          * See the "Rules for __asm__ statements in __PIC__ code" above: %3
          * must use a register class which does not contain %ebx.
          * "a"/"c"/"d" are already used, so we are left with either "S" or "D".
+         *
+         * Note that this assembly uses ALL GP registers (with %esp reserved for
+         * stack, %ebp reserved for frame, %ebx reserved for PIC).
          */
-        "S,D" (var),
-        "1,1" (((S_uint64 const *)oldVal)->lowValue),
-        "2,2" (((S_uint64 const *)oldVal)->highValue),
-        // %6 cannot use "m": 'newVal' is read-only.
-        "r,r" (((S_uint64 const *)newVal)->lowValue),
-        "c,c" (((S_uint64 const *)newVal)->highValue)
+        "S" (var),
+        "1" (((S_uint64 const *)oldVal)->lowValue),
+        "2" (((S_uint64 const *)oldVal)->highValue),
+        "D" (((S_uint64 const *)newVal)->lowValue),
+        "c" (((S_uint64 const *)newVal)->highValue)
       : "cc", "memory"
    );
 #      endif
@@ -1634,27 +1739,7 @@ Atomic_CMPXCHG64(Atomic_uint64 *var,   // IN/OUT
       : "cc"
    );
 #   endif
-#elif defined(VM_ARM_V7)
-   volatile uint64 tmp;
-
-   dmb();
-
-   __asm__ __volatile__(
-      "ldrexd %[tmp], %H[tmp], [%[var]] \n\t"
-      "mov %[equal], #1 \n\t"
-      "teq %[tmp], %[oldVal] \n\t"
-      "teqeq %H[tmp], %H[oldVal] \n\t"
-      "strexdeq  %[equal], %[newVal], %H[newVal], [%[var]]"
-      : [equal] "=&r" (equal), [tmp] "=&r" (tmp)
-      : [var] "r" (&var->value), [oldVal] "r" (*oldVal), [newVal] "r" (*newVal)
-      : "memory", "cc"
-   );
-
-   dmb();
-
-   return !equal;
 #endif
-#ifndef VM_ARM_V7
    AtomicEpilogue();
    return equal;
 #endif // VM_ARM_V7
@@ -1708,27 +1793,18 @@ Atomic_CMPXCHG32(Atomic_uint32 *var,   // IN/OUT
                  uint32 oldVal, // IN
                  uint32 newVal) // IN
 {
-#ifdef __GNUC__
-   Bool equal;
-#ifdef VM_ARM_V7
-   volatile uint64 tmp;
-
-   dmb();
-
-   __asm__ __volatile__(
-      "ldrex %[tmp], [%[var]] \n\t"
-      "mov %[equal], #1 \n\t"
-      "teq %[tmp], %[oldVal] \n\t"
-      "strexeq  %[equal], %[newVal], [%[var]]"
-      : [equal] "=&r" (equal), [tmp] "=&r" (tmp)
-      : [var] "r" (&var->value), [oldVal] "r" (oldVal), [newVal] "r" (newVal)
-      : "memory", "cc"
-   );
-
-   dmb();
+#ifdef FAKE_ATOMIC
+   uint32 readVal = var->value;
 
-   return !equal;
+   if (oldVal == readVal) {
+     var->value = newVal;
+   }
+   return (oldVal == readVal);
+#elif defined(__GNUC__)
+#ifdef VM_ARM_V7
+   return (Atomic_ReadIfEqualWrite(var, oldVal, newVal) == oldVal);
 #else // VM_ARM_V7
+   Bool equal;
    uint32 dummy;
 
    __asm__ __volatile__(
@@ -1769,7 +1845,9 @@ Atomic_CMPXCHG32(Atomic_uint32 *var,   // IN/OUT
 static INLINE uint64
 Atomic_Read64(Atomic_uint64 const *var) // IN
 {
-#if defined(__GNUC__) && defined(__x86_64__)
+#ifdef FAKE_ATOMIC
+   return var->value;
+#elif defined(__GNUC__) && defined(__x86_64__)
    uint64 value;
 
 #ifdef VMM
@@ -2228,15 +2306,162 @@ Atomic_And64(Atomic_uint64 *var, // IN
 
 
 /*
+ *-----------------------------------------------------------------------------
+ *
+ * Atomic_SetBit64 --
+ *
+ *      Atomic read, set bit N, and write.
+ *      Be careful: if bit is in a register (not in an immediate), then it 
+ *      can specify a bit offset above 63 or even a negative offset.
+ *
+ * Results:
+ *      None
+ *
+ * Side effects:
+ *      None
+ *
+ *-----------------------------------------------------------------------------
+ */
+static INLINE void
+Atomic_SetBit64(Atomic_uint64 *var, // IN/OUT
+                uint64 bit)         // IN
+{
+#if defined(__x86_64__)
+#if defined(__GNUC__)
+   __asm__ __volatile__(
+      "lock; bts %1, %0"
+      : "+m" (var->value)
+      : "ri" (bit)
+      : "cc"
+   );
+   AtomicEpilogue();
+#elif defined _MSC_VER
+   uint64 oldVal;
+   uint64 newVal;
+   do {
+      oldVal = var->value;
+      newVal = oldVal | (CONST64U(1) << bit);
+   } while (!Atomic_CMPXCHG64(var, &oldVal, &newVal));
+#else
+#error No compiler defined for Atomic_SetBit64
+#endif
+#else // __x86_64__
+   uint64 oldVal;
+   uint64 newVal;
+   do {
+      oldVal = var->value;
+      newVal = oldVal | (CONST64U(1) << bit);
+   } while (!Atomic_CMPXCHG64(var, &oldVal, &newVal));
+#endif
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Atomic_ClearBit64 --
+ *
+ *      Atomic read, clear bit N, and write.
+ *      Be careful: if bit is in a register (not in an immediate), then it 
+ *      can specify a bit offset above 63 or even a negative offset.
+ *
+ * Results:
+ *      None
+ *
+ * Side effects:
+ *      None
+ *
+ *-----------------------------------------------------------------------------
+ */
+static INLINE void
+Atomic_ClearBit64(Atomic_uint64 *var, // IN/OUT
+                  uint64 bit)         // IN
+{
+#if defined(__x86_64__)
+#if defined(__GNUC__)
+   __asm__ __volatile__(
+      "lock; btr %1, %0"
+      : "+m" (var->value)
+      : "ri" (bit)
+      : "cc"
+   );
+   AtomicEpilogue();
+#elif defined _MSC_VER
+   uint64 oldVal;
+   uint64 newVal;
+   do {
+      oldVal = var->value;
+      newVal = oldVal & ~(CONST64U(1) << bit);
+   } while (!Atomic_CMPXCHG64(var, &oldVal, &newVal));
+#else
+#error No compiler defined for Atomic_ClearBit64
+#endif
+#else // __x86_64__
+   uint64 oldVal;
+   uint64 newVal;
+   do {
+      oldVal = var->value;
+      newVal = oldVal & ~(CONST64U(1) << bit);
+   } while (!Atomic_CMPXCHG64(var, &oldVal, &newVal));
+#endif
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Atomic_TestBit64 --
+ *
+ *      Read a bit.
+ *      Be careful: if bit is in a register (not in an immediate), then it 
+ *      can specify a bit offset above 63 or even a negative offset.
+ *
+ * Results:
+ *      TRUE if the tested bit was set; else FALSE.
+ *
+ * Side effects:
+ *      None
+ *
+ *-----------------------------------------------------------------------------
+ */
+static INLINE Bool
+Atomic_TestBit64(Atomic_uint64 *var, // IN
+                 uint64 bit)         // IN
+{
+#if defined(__x86_64__)
+#if defined(__GNUC__)
+   Bool out = FALSE;
+   __asm__ __volatile__(
+      "bt %2, %1; setc %0"
+      : "=rm"(out)
+      : "m" (var->value),
+        "rJ" (bit)
+      : "cc"
+   );
+   return out;
+#elif defined _MSC_VER
+   return (var->value & (CONST64U(1) << bit)) != 0;
+#else
+#error No compiler defined for Atomic_TestBit64
+#endif
+#else // __x86_64__
+   return (var->value & (CONST64U(1) << bit)) != 0;
+#endif
+}
+
+/*
  * Template code for the Atomic_<name> type and its operators.
  *
- * The cast argument is an intermedia type cast to make some
+ * The cast argument is an intermediate type cast to make some
  * compilers stop complaining about casting uint32 <-> void *,
  * even though we only do it in the 32-bit case so they are always
  * the same size.  So for val of type uint32, instead of
  * (void *)val, we have (void *)(uintptr_t)val.
  * The specific problem case is the Windows ddk compiler
  * (as used by the SVGA driver).  -- edward
+ *
+ * NOTE: See the comment in vm_assert.h for why we need UNUSED_TYPE in
+ * AtomicAssertOnCompile(), and why we need to be very careful doing so.
  */
 
 #define MAKE_ATOMIC_TYPE(name, size, in, out, cast)                           \
@@ -2250,7 +2475,7 @@ Atomic_And64(Atomic_uint64 *var, // IN
                                       && 8 * sizeof (out) == size             \
                                       && 8 * sizeof (cast) == size            \
                                          ? 1 : -1 };                          \
-      typedef char AssertOnCompileFailed[AssertOnCompileMisused];             \
+      UNUSED_TYPE(typedef char AssertOnCompileFailed[AssertOnCompileMisused]);\
    }                                                                          \
                                                                               \
                                                                               \
@@ -2418,6 +2643,16 @@ MAKE_ATOMIC_TYPE(Ptr, 32, void const *, void *, uintptr_t)
 MAKE_ATOMIC_TYPE(Int, 32, int, int, int)
 
 
+/* Prevent the compiler from re-ordering memory references. */
+#ifdef __GNUC__
+#define ATOMIC_COMPILER_BARRIER()   __asm__ __volatile__ ("": : :"memory")
+#elif defined(_MSC_VER)
+#define ATOMIC_COMPILER_BARRIER()   _ReadWriteBarrier()
+#else
+#error No compiler defined for ATOMIC_COMPILER_BARRIER
+#endif
+
+
 /*
  *-----------------------------------------------------------------------------
  *
@@ -2442,7 +2677,13 @@ static INLINE void
 Atomic_MFence(void)
 {
    Atomic_uint32 fence;
+   ATOMIC_COMPILER_BARRIER();
    Atomic_Xor(&fence, 0x1);
+   ATOMIC_COMPILER_BARRIER();
 }
 
+#ifdef ATOMIC_COMPILER_BARRIER
+#undef ATOMIC_COMPILER_BARRIER
+#endif
+
 #endif // ifndef _ATOMIC_H_
